BaySeqNB <-
function(x,conditions,list_nde,list_de,estType,samsize,sA,sB,the.file,fdr,Project){

require(baySeq)

  #conditions = c("C9","C9","C10","C10")
  #samsize = 1000
  #estType = "quantile"
  #list_nde = c(1,1,1,1)
  #list_de = c(1,1,2,2)
  #x <- read.table("a1", header=TRUE, row.names=1) #Gene names are loaded

  set.seed(102)
  options(width = 90)
  samsize = as.numeric(samsize)
  fdr = as.numeric(fdr)

  counts = data.matrix(x, rownames.force = NA)

  head(counts)

  CD <- new("countData", data = counts)

  libsizes(CD) <- getLibsizes(CD, estimationType = estType)

  replicates(CD) = conditions

  NDE = as.numeric(list_nde)
  #NDE = c(1,1,1,1)

  DE = as.numeric(list_de)
  #DE = c(1,1,2,2)

  groups(CD) <- list(NDE = NDE, DE = DE)
  
  CD

  CD <- getPriors.NB(CD, samplesize = samsize, estimation = "QL", cl = NULL)

  CD <- getLikelihoods.NB(CD, pET = 'BIC', cl = NULL)

  plotMA.CD(CD, samplesA = sA, samplesB = sB, col = c(rep("red", 100), rep("black", 900)))

 if(Sys.info()[[1]]=="Windows"){

  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")

  the.file = strsplit(the.file,"\\\\")

  the.file = the.file[[1]][length(the.file[[1]])]  #estract the namefile

  outputName=paste(the.file,"_PlotMA_BaySeqNB.pdf", sep="")

  b=paste(a,outputName,sep="\\")

  dev.print(device = pdf, file=b)

  dev.off()

  CD@estProps

  bayseq_table = topCounts(CD, group="DE", decreasing = TRUE, number = nrow( CD@data )) # PRINT THE ENTIRE TABLE of results

  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Results\\",sep="")

  outputName=paste(the.file,"_results_BaySeqNB.txt", sep="")

  b=paste(a,outputName,sep="\\")

  write.table(bayseq_table, file = b , quote=FALSE, sep="\t", row.names=TRUE)

  plotPosteriors(CD, group = "DE", col = c(rep("red", 100), rep("black", 900)))

  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")

  outputName=paste(the.file,"_Posteriors_BaySeqNB.pdf", sep="")

  b=paste(a,outputName,sep="\\")

  dev.print(device = pdf, file=b)

  # Now print the table of results with FDR < 0.05

  bayseq_table_FDR = subset(bayseq_table, FDR.DE < fdr)

  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Results\\",sep="")

  outputName=paste(the.file,"_fdr=",fdr,"_DE_genes_BaySeqNB.txt", sep="")

  b=paste(a,outputName,sep="\\")

  write.table(bayseq_table_FDR, file = b , quote=FALSE, sep="\t", row.names=TRUE)

     message=paste("Results of BaySeqNB have been saved in the ", Project,"\\Results folder!", sep="")
     print(message)
     #write into the project report
     report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.txt",sep="") 
     message2 <- paste("You ckicked the Run BaySeq with NB button at ", Sys.time()," and the results have been saved in the ", Project,"\\Results folder!", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 
     message2 <- paste("You chose the following count file: ",the.file," and FDR: ",fdr, sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

  bayseq_table
  
 }else{

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="")

  the.file = strsplit(the.file,"/")

  the.file = the.file[[1]][length(the.file[[1]])]  #estract the namefile

  outputName=paste(the.file,"_PlotMA_BaySeqNB.pdf", sep="")

  b=paste(a,outputName,sep="/")

  dev.print(device = pdf, file=b)

  dev.off()

  CD@estProps

  bayseq_table = topCounts(CD, group="DE", decreasing = TRUE, number = nrow( CD@data )) # PRINT THE ENTIRE TABLE of results

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Results/",sep="")

  outputName=paste(the.file,"_results_BaySeqNB.txt", sep="")

  b=paste(a,outputName,sep="/")

  write.table(bayseq_table, file = b , quote=FALSE, sep="\t", row.names=TRUE)

  plotPosteriors(CD, group = "DE", col = c(rep("red", 100), rep("black", 900)))

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="")

  outputName=paste(the.file,"_Posteriors_BaySeqNB.pdf", sep="")

  b=paste(a,outputName,sep="/")

  dev.print(device = pdf, file=b)

  # Now print the table of results with FDR < 0.05

  bayseq_table_FDR = subset(bayseq_table, FDR.DE < fdr)

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Results/",sep="")

  outputName=paste(the.file,"_fdr=",fdr,"_DE_genes_BaySeqNB.txt", sep="")

  b=paste(a,outputName,sep="/")

  write.table(bayseq_table_FDR, file = b , quote=FALSE, sep="\t", row.names=TRUE)

     message=paste("Results of BaySeqNB have been saved in the ", Project,"/Results folder!", sep="")
     print(message)
     #write into the project report
     report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.txt",sep="") 
     message2 <- paste("You ckicked the Run BaySeq with NB button at ", Sys.time()," and the results have been saved in the ", Project,"/Results folder!", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 
     message2 <- paste("You chose the following count file: ",the.file," and FDR: ",fdr, sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

  bayseq_table
 }

}
