EdgeR2 <-
function(x,n,factors,the.file,fdr,Project){

require(edgeR)

  #x <- read.table("a", header=TRUE, row.names=1) #Gene names are loaded
  #the.file = "pippo/pluto/a"
  #n=4
  #factors=c(1,1,2,2)

  fdr = as.numeric(fdr)

  g <- factor(factors)

  res9 <- DGEList(counts = x[,1:n], group=g)  # modify here the entries of the count columns

  head(counts)

  colnames(res9) <- factor(c(1:n))

  res9 <- calcNormFactors(res9)

  res9 <- estimateCommonDisp(res9, verbose=TRUE)

  res9 <- estimateTagwiseDisp(res9)

 if(Sys.info()[[1]]=="Windows"){
  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")
  the.file = strsplit(the.file,"\\\\")
  the.file = the.file[[1]][length(the.file[[1]])]  #estract the namefile

  outputName=paste(the.file,"_DispersionEdgeR.pdf", sep="")

  b=paste(a,outputName,sep="")

  plotBCV(res9)

  dev.print(device = pdf, file=b)

  dev.off()

  outputName=paste(the.file,"_MDS_EdgeR.pdf", sep="")

  b=paste(a,outputName,sep="\\")

  plotBCV(res9)

  dev.print(device = pdf, file=b)

  dev.off()

  plotMDS(res9, main="MDS Plot")

  dev.print(device = pdf, file=b)

  et9 <- exactTest(res9)  

  et9_results <- topTags( et9 , n = nrow( et9$table ) , sort.by = "none" )$table # n = nrow( et9$table ) is used to print all results!

  a=paste(substring(getwd(),1,nchar(getwd())),"\\RNASeqGUI_Projects\\",Project,"\\Results\\",sep="")

  outputName=paste(the.file,"_results_EdgeR.txt", sep="")

  b=paste(a,outputName,sep="\\")

  write.table( et9_results, file = b , quote=FALSE, sep="\t", row.names=TRUE)

  list_DE_EDGER = subset(et9_results, FDR<fdr) # select significant genes

  #de <- decideTestsDGE(et9) #genes significantly up-regulated or down-regulated at 5% FDR

  #isDE <- as.logical(de)

  #DEnames <- rownames(res9)[isDE]

  outputName=paste(the.file,"_fdr=",fdr,"_DE_genes_EDGER.txt", sep="")

  b=paste(a,outputName,sep="\\")

  write.table(list_DE_EDGER, file = b , quote=FALSE, sep="\t", row.names=TRUE)

     message=paste("Results of EdgeR have been saved in the ", Project,"\\Results folder!", sep="")
     print(message)
     #write into the project report
     report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.txt",sep="") 
     message2 <- paste("You ckicked the Run EdgeR button at ", Sys.time()," and the results have been saved in the ", Project,"/Results folder!", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 
     message2 <- paste("You chose the following count file: ",the.file," and FDR: ",fdr, sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

  et9_results

 }else{

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="")

  the.file = strsplit(the.file,"/")

  the.file = the.file[[1]][length(the.file[[1]])]  #estract the namefile

  outputName=paste(the.file,"_DispersionEdgeR.pdf", sep="")

  b=paste(a,outputName,sep="")

  plotBCV(res9)

  dev.print(device = pdf, file=b)

  dev.off()

  outputName=paste(the.file,"_MDS_EdgeR.pdf", sep="")

  b=paste(a,outputName,sep="/")

  plotBCV(res9)

  dev.print(device = pdf, file=b)

  dev.off()

  plotMDS(res9, main="MDS Plot")

  dev.print(device = pdf, file=b)

  et9 <- exactTest(res9)  

  et9_results <- topTags( et9 , n = nrow( et9$table ) , sort.by = "none" )$table # n = nrow( et9$table ) is used to print all results!

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Results/",sep="")

  outputName=paste(the.file,"_results_EdgeR.txt", sep="")

  b=paste(a,outputName,sep="/")

  write.table( et9_results, file = b , quote=FALSE, sep="\t", row.names=TRUE)

  list_DE_EDGER = subset(et9_results, FDR<fdr) # select significant genes

  #de <- decideTestsDGE(et9) #genes significantly up-regulated or down-regulated at 5% FDR

  #isDE <- as.logical(de)

  #DEnames <- rownames(res9)[isDE]

  outputName=paste(the.file,"_fdr=",fdr,"_DE_genes_EDGER.txt", sep="")

  b=paste(a,outputName,sep="/")

  write.table(list_DE_EDGER, file = b , quote=FALSE, sep="\t", row.names=TRUE)

     message=paste("Results of EdgeR have been saved in the ", Project,"/Results folder!", sep="")
     print(message)
     #write into the project report
     report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.txt",sep="") 
     message2 <- paste("You ckicked the Run EdgeR button at ", Sys.time()," and the results have been saved in the ", Project,"/Results folder!", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 
     message2 <- paste("You chose the following count file: ",the.file," and FDR: ",fdr, sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

  et9_results

 }

}
