NEWDESeq2 <-
function(x,conditions,libTypes,treated,control,the.file,pvaladj,Project){

  require(DESeq2)

  pvaladj = as.numeric(pvaladj)

  #x <- read.table("a", header=TRUE, row.names=1) #Gene names are loaded
 
  countData <- x

  colData = data.frame(row.names=colnames(countData), condition=conditions, libType=libTypes)
  #colData = data.frame(row.names=colnames(countData),condition=c("treated","treated","control","control"),libType=c("paired-end","paired-end","paired-end","paired-end"))

  dds <- DESeqDataSetFromMatrix(countData = countData, colData = colData, design = ~ condition)

  colData(dds)$condition <- factor(colData(dds)$condition, levels=c(treated,control))
  #colData(dds)$condition <- factor(colData(dds)$condition, levels=c("treated","control"))

  ######################################## ANALISYS ###################################

  dds <- DESeq2::DESeq(dds)

  res <- results(dds)

 if(Sys.info()[[1]]=="Windows"){
  a=paste(getwd(),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")
  the.file = strsplit(the.file,"\\\\") 

the.file = the.file[[1]][length(the.file[[1]])]  #estract the namefile

  outputName=paste(the.file,"_results_DESeq2.txt", sep="")

     message=paste("Results of DESeq2 have been saved in the ", Project,"\\Results folder!", sep="")
     print(message)
     #write into the project report
     report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.txt",sep="") 
     message2 <- paste("You ckicked the Run DESeq2 button at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"\\Results folder!", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 

  b=paste(a,outputName,sep="\\")

  write.table( as.data.frame(res), file = b, quote=FALSE, sep="\t", row.names=TRUE)  

  list_DE_DESEQ2 = subset(as.data.frame(res), padj < pvaladj) # select significant genes

  outputName=paste(the.file,"_padj=",pvaladj,"_DE_genes_DESEQ2.txt", sep="")

     message2 <- paste("You ckicked the Run DESeq2 button at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"\\Results folder!", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 

  b=paste(a,outputName,sep="\\")

  write.table(list_DE_DESEQ2, file = b , quote=FALSE, sep="\t", row.names=TRUE) 
 
  #PLOTS 

  a=paste(substring(getwd(),1,nchar(getwd())),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="")

  outputName=paste(the.file,"_Dispersion_Local_DESeq2.pdf", sep="")

  b=paste(a,outputName,sep="\\")

  ddsLocal <- estimateDispersions(dds, fitType="local")
  DESeq2::plotDispEsts(ddsLocal)
  dev.print(device = pdf, file=b)
  dev.off()

  outputName=paste(the.file,"_Dispersion_Mean_DESeq2.pdf", sep="")

  b=paste(a,outputName,sep="\\")


  ddsMean <- estimateDispersions(dds, fitType="mean")
  DESeq2::plotDispEsts(ddsMean)
  dev.print(device = pdf, file=b)
  dev.off()

  outputName=paste(the.file,"_Dispersion_DESeq2.pdf", sep="")

  b=paste(a,outputName,sep="\\")

  DESeq2::plotDispEsts(dds)
  dev.print(device = pdf, file=b)
  dev.off()


     message2 <- paste("You chose the following count file: ",the.file," and Padj: ",pvaladj, sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")


 }else{

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Results/",sep="")

  the.file = strsplit(the.file,"/")

  the.file = the.file[[1]][length(the.file[[1]])]  #estract the namefile

  outputName=paste(the.file,"_results_DESeq2.txt", sep="")

     message=paste("Results of DESeq2 have been saved in the ", Project,"/Results folder!", sep="")
     print(message)
     #write into the project report
     report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.txt",sep="") 
     message2 <- paste("You ckicked the Run DESeq2 button at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"/Results folder!", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 

  b=paste(a,outputName,sep="/")

  write.table( as.data.frame(res), file = b, quote=FALSE, sep="\t", row.names=TRUE)  

  list_DE_DESEQ2 = subset(as.data.frame(res), padj < pvaladj) # select significant genes

  outputName=paste(the.file,"_padj=",pvaladj,"_DE_genes_DESEQ2.txt", sep="")

     message2 <- paste("You ckicked the Run DESeq2 button at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"/Results folder!", sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n") 

  b=paste(a,outputName,sep="/")

  write.table(list_DE_DESEQ2, file = b , quote=FALSE, sep="\t", row.names=TRUE) 
 
  #PLOTS 

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="")

  outputName=paste(the.file,"_Dispersion_Local_DESeq2.pdf", sep="")

  b=paste(a,outputName,sep="/")

  ddsLocal <- estimateDispersions(dds, fitType="local")
  DESeq2::plotDispEsts(ddsLocal)
  dev.print(device = pdf, file=b)
  dev.off()

  outputName=paste(the.file,"_Dispersion_Mean_DESeq2.pdf", sep="")

  b=paste(a,outputName,sep="/")


  ddsMean <- estimateDispersions(dds, fitType="mean")
  DESeq2::plotDispEsts(ddsMean)
  dev.print(device = pdf, file=b)
  dev.off()

  outputName=paste(the.file,"_Dispersion_DESeq2.pdf", sep="")

  b=paste(a,outputName,sep="/")

  DESeq2::plotDispEsts(dds)
  dev.print(device = pdf, file=b)
  dev.off()


     message2 <- paste("You chose the following count file: ",the.file," and Padj: ",pvaladj, sep="")
     write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

 }

  res

}
