Venn2de <-
function(x,y,label1,label2,Project){

  a15 = row.names(x)

  b15 = row.names(y)

  c15 <- intersect(a15,b15)     #common gene names

  Lists <- list(a15, b15)  #put the word vectors into a list to supply lapply  
  Lists <- lapply(Lists, function(x) as.character(unlist(x)))
  items <- sort(unique(unlist(Lists)))   #put in alphabetical order
  MAT <- matrix(rep(0, length(items)*length(Lists)), ncol=2)  #make a matrix of 0's
  names <- c(label1,label2)                
  colnames(MAT) <- names
  rownames(MAT) <- items
  lapply(seq_along(Lists), function(i) {   #fill the matrix
      MAT[items %in% Lists[[i]], i] <<- table(Lists[[i]])
  })
  #MAT   #look at the results

if(Sys.info()[[1]]=="Windows"){
  a=paste(substring(getwd(),1,nchar(getwd())),"\\RNASeqGUI_Projects\\",Project,"\\Results\\",sep="") #eliminate "src" and put "Results"

  outputName=paste(label1,"_",label2,"_genes_in_intersection.txt",sep="")

  b=paste(a,outputName,sep="")

  write.table(c15, file = b , quote=FALSE, sep="\t", row.names=FALSE)


  a=paste(substring(getwd(),1,nchar(getwd())),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="") #eliminate "src" and put "Plots"

  outputName=paste(label1,"_",label2,"_VennDiagramDE.pdf",sep="")

  b=paste(a,outputName,sep="")

  vennDiagram(MAT,circle.col= c("red","green"),main="Venn Diagram of DE genes")

  dev.print(device = pdf, file=b)

 #write into the project report
 report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.txt",sep="") 
 message=paste("The ",outputName," file has been saved in the ", Project,"\\Plots folder!", sep="")
 print(message)
 message2 <- paste("You ckicked the VennDiagrams 2 sets DE button in the Result Comparison Interface at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"\\Plots folder!", sep="")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

  }else{

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Results/",sep="") #eliminate "src" and put "Results"

  outputName=paste(label1,"_",label2,"_genes_in_intersection.txt",sep="")

  b=paste(a,outputName,sep="")

  write.table(c15, file = b , quote=FALSE, sep="\t", row.names=FALSE)


  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="") #eliminate "src" and put "Plots"

  outputName=paste(label1,"_",label2,"_VennDiagramDE.pdf",sep="")

  b=paste(a,outputName,sep="")

  vennDiagram(MAT,circle.col= c("red","green"),main="Venn Diagram of DE genes")

  dev.print(device = pdf, file=b)

 #write into the project report
 report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.txt",sep="") 
 message=paste("The ",outputName," file has been saved in the ", Project,"/Plots folder!", sep="")
 print(message)
 message2 <- paste("You ckicked the VennDiagrams 2 sets DE button in the Result Comparison Interface at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"/Plots folder!", sep="")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

}

}
