Venn3de <-
function(x,y,z,label1,label2,label3,Project){

  a = row.names(x)
  b = row.names(y)
  c = row.names(z)
  d <- intersect(a,b)     #common gene names
  e <- intersect(d,c)     #common gene names

  Lists <- list(a, b, c)  #put the word vectors into a list to supply lapply  
  Lists <- lapply(Lists, function(x) as.character(unlist(x)))
  items <- sort(unique(unlist(Lists)))   #put in alphabetical order
  MAT <- matrix(rep(0, length(items)*length(Lists)), ncol=3)  #make a matrix of 0's
  names <- c(label1,label2,label3)                
  colnames(MAT) <- names
  rownames(MAT) <- items
  lapply(seq_along(Lists), function(i) {   #fill the matrix
      MAT[items %in% Lists[[i]], i] <<- table(Lists[[i]])
  })
  #MAT   #look at the results

if(Sys.info()[[1]]=="Windows"){
  a=paste(substring(getwd(),1,nchar(getwd())),"\\RNASeqGUI_Projects\\",Project,"\\Results\\",sep="") #eliminate "src" and put "Results"
  outputName=paste(label1,"_",label2,"_",label3,"_genes_in_intersection.txt",sep="")

  b=paste(a,outputName,sep="")

  write.table(e, file = b , quote=FALSE, sep="\t", row.names=FALSE)


  a=paste(substring(getwd(),1,nchar(getwd())),"\\RNASeqGUI_Projects\\",Project,"\\Plots\\",sep="") #eliminate "src" and put "Plots"

  outputName=paste(label1,"_",label2,"_",label3,"_VennDiagramDE.pdf",sep="")

  b=paste(a,outputName,sep="")

  vennDiagram(MAT, circle.col= c("red","green","yellow"), main="Venn Diagram of DE genes")

  dev.print(device = pdf, file=b)

 #write into the project report
 report=paste("RNASeqGUI_Projects\\",Project,"\\Logs\\report.txt",sep="") 
 message=paste("The ",outputName," file has been saved in the ", Project,"\\Plots folder!", sep="")
 print(message)
 message2 <- paste("You ckicked the VennDiagrams 3 sets DE button in the Result Comparison Interface at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"\\Plots folder!", sep="")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

}else{

  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Results/",sep="") #eliminate "src" and put "Results"

  outputName=paste(label1,"_",label2,"_",label3,"_genes_in_intersection.txt",sep="")

  b=paste(a,outputName,sep="")

  write.table(e, file = b , quote=FALSE, sep="\t", row.names=FALSE)


  a=paste(substring(getwd(),1,nchar(getwd())),"/RNASeqGUI_Projects/",Project,"/Plots/",sep="") #eliminate "src" and put "Plots"

  outputName=paste(label1,"_",label2,"_",label3,"_VennDiagramDE.pdf",sep="")

  b=paste(a,outputName,sep="")

  vennDiagram(MAT, circle.col= c("red","green","yellow"), main="Venn Diagram of DE genes")

  dev.print(device = pdf, file=b)

 #write into the project report
 report=paste("RNASeqGUI_Projects/",Project,"/Logs/report.txt",sep="") 
 message=paste("The ",outputName," file has been saved in the ", Project,"/Plots folder!", sep="")
 print(message)
 message2 <- paste("You ckicked the VennDiagrams 3 sets DE button in the Result Comparison Interface at ", Sys.time()," and the ",outputName," file has been saved in the ", Project,"/Plots folder!", sep="")
 write(message2, file = report,ncolumns = if(is.character(message2)) 1 else 5,append = TRUE, sep = "\n")

}

}
